<?php
namespace Inti\Container;

use Inti\Config\Service\ConfigManager;
use Inti\Config\Service\ConfigManagerInterface;
use Psr\Container\ContainerInterface;
use Laminas\ServiceManager\ServiceManager;

/**
 * Class ContainerFactory
 *
 * @package Inti\Container
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-container
 */
final class ContainerFactory
{
    /**
     * @param ConfigManagerInterface|null $configManager
     * @return ContainerInterface
     */
    public function __invoke(ConfigManagerInterface $configManager = null): ContainerInterface
    {
        if ($configManager instanceof ConfigManagerInterface) {
            $config = $configManager->getConfig()->getArrayCopy();
            $dependencies = $config['dependencies'] ?? [];

            $dependencies['services'][ConfigManager::CONTAINER_KEY] = $configManager;
            $dependencies['services']['config'] = $config;
        }

        return new ServiceManager($dependencies ?? []);
    }
}
